' This class is "generated" and will be overwritten.
' Your customizations should be made in BornRecord.vb

Imports System.Data.SqlTypes
Imports BaseClasses
Imports BaseClasses.Data
Imports BaseClasses.Data.SqlProvider

Namespace Persons.Business

''' <summary>
''' The generated superclass for the <see cref="BornRecord"></see> class.
''' </summary>
''' <remarks>
''' This class is not intended to be instantiated directly.  To obtain an instance of this class, 
''' use the methods of the <see cref="BornTable"></see> class.
''' </remarks>
''' <seealso cref="BornTable"></seealso>
''' <seealso cref="BornRecord"></seealso>

<Serializable()> Public Class BaseBornRecord
	Inherits PrimaryKeyRecord
	

	Public Shared Shadows ReadOnly TableUtils As BornTable = BornTable.Instance

	' Constructors
 
	Protected Sub New()
		MyBase.New(TableUtils)
	End Sub

	Protected Sub New(ByVal record As PrimaryKeyRecord)
		MyBase.New(record, TableUtils)
	End Sub
	
	'Evaluates Initialize when->Inserting record formulas specified at the data access layer
    Public Overridable Sub BornRecord_InsertingRecord(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.InsertingRecord
        'Apply Initialize->Inserting record formula only if validation is successful.
        	        Dim BornRec As BornRecord = CType(sender,BornRecord)
        Validate_Inserting()
        If Not BornRec Is Nothing AndAlso Not BornRec.IsReadOnly Then
                End If
    End Sub

	'Evaluates Initialize when->Updating record formulas specified at the data access layer
    Public Overridable Sub BornRecord_UpdatingRecord(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.UpdatingRecord
        'Apply Initialize->Updating record formula only if validation is successful.
        	        Dim BornRec As BornRecord = CType(sender,BornRecord)
        Validate_Updating()
        If Not BornRec Is Nothing AndAlso Not BornRec.IsReadOnly Then
                End If
    End Sub
    
    'Evaluates Initialize when->Reading record formulas specified at the data access layer
    Public Overridable Sub BornRecord_ReadRecord(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ReadRecord
        'Apply Initialize->Reading record formula only if validation is successful.
        	        Dim BornRec As BornRecord = CType(sender,BornRecord)
        If Not BornRec Is Nothing AndAlso Not BornRec.IsReadOnly Then
                End If
    End Sub
    
   'Evaluates Validate when->Inserting formulas specified at the data access layer
   Public Overridable Sub Validate_Inserting ()
		Dim fullValidationMessage As String = ""
		Dim validationMessage As String = ""

		dim formula as String = ""


		If validationMessage <> "" AndAlso validationMessage.ToLower() <> "true" Then
			fullValidationMessage &= validationMessage & vbCrLf
		End If

		If fullValidationMessage <> "" Then
			Throw New Exception(fullValidationMessage)
		End If 
	End Sub
	
	'Evaluates Validate when->Updating formulas specified at the data access layer
   Public Overridable Sub Validate_Updating ()
		Dim fullValidationMessage As String = ""
		Dim validationMessage As String = ""

		dim formula as String = ""


		If validationMessage <> "" AndAlso validationMessage.ToLower() <> "true" Then
			fullValidationMessage &= validationMessage & vbCrLf
		End If

		If fullValidationMessage <> "" Then
			Throw New Exception(fullValidationMessage)
		End If 
	End Sub
 
	Public Overridable Function EvaluateFormula(ByVal formula As String, Optional ByVal dataSourceForEvaluate As BaseClasses.Data.BaseRecord = Nothing, Optional ByVal format As String = Nothing) As String

		Dim e As Data.BaseFormulaEvaluator = New Data.BaseFormulaEvaluator()

            ' All variables referred to in the formula are expected to be
            ' properties of the DataSource.  For example, referring to
            ' UnitPrice as a variable will refer to DataSource.UnitPrice
            e.DataSource = dataSourceForEvaluate

            Dim resultObj As Object = e.Evaluate(formula)
            If resultObj Is Nothing Then
                Return ""
            End If
        	Return resultObj.ToString()
	End Function







#Region "Convenience methods to get/set values of fields"

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Born_.Born field.
	''' </summary>
	Public Function GetBornValue() As ColumnValue
		Return Me.GetValue(TableUtils.BornColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Born_.Born field.
	''' </summary>
	Public Function GetBornFieldValue() As String
		Return CType(Me.GetValue(TableUtils.BornColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Born_.Born field.
	''' </summary>
	Public Sub SetBornFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.BornColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Born_.Born field.
	''' </summary>
	Public Sub SetBornFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.BornColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Born_.BornDesc field.
	''' </summary>
	Public Function GetBornDescValue() As ColumnValue
		Return Me.GetValue(TableUtils.BornDescColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Born_.BornDesc field.
	''' </summary>
	Public Function GetBornDescFieldValue() As String
		Return CType(Me.GetValue(TableUtils.BornDescColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Born_.BornDesc field.
	''' </summary>
	Public Sub SetBornDescFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.BornDescColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Born_.BornDesc field.
	''' </summary>
	Public Sub SetBornDescFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.BornDescColumn)
	End Sub



#End Region

#Region "Convenience methods to get field names"

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Born_.Born field.
	''' </summary>
	Public Property Born() As String
		Get 
			Return CType(Me.GetValue(TableUtils.BornColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.BornColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property BornSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.BornColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property BornDefault() As String
        Get
            Return TableUtils.BornColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Born_.BornDesc field.
	''' </summary>
	Public Property BornDesc() As String
		Get 
			Return CType(Me.GetValue(TableUtils.BornDescColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.BornDescColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property BornDescSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.BornDescColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property BornDescDefault() As String
        Get
            Return TableUtils.BornDescColumn.DefaultValue
        End Get
    End Property



#End Region

End Class
End Namespace
